//"diag_dp.sc","51dp : diagnostyka pozycji handlowych",12004,0,1.0.4,SYSTEM
//"Diagnostyka",12001,14,16
////////////////////////////
// 51dp : diagnostyka pozycji handlowych
// diag_dp.sc
////////////////////////////
// Napisa: Sebastian Nowak
// data:    98.07.10


#ifdef HM
#define HMHL
#endif
#ifdef HL
#define HMHL
#endif
#define NAZWA_PLIKU "DIAG_DP.TXT"

///////////////////////////////////////////////////////////////////////////
// dokumenty sprzeday
#define FVS      40     // faktura VAT
#define FKS      41     // faktura korygujca VAT
#define RUS      42     // rachunek uproszczony
#define RKS      43     // rachunek korygujcy VAT
#define PAR		 50		// paragon
#define PRK 	 51		//paragon korekta		
#define FVW		101		// f-ra VAT w walucie
#define FKW		102		// korekta VAT w walucie
#define FVM		106		//Faktura VAT MP
#define FKM		107		//Faktura korygujaca VAT MP
#define FZS		108		//Faktura zaliczkowa
#define KZS		109		//Kontrakt zaliczkowy
#define ZKS		112		//Faktura korygujca zaliczkowa
#define WDT		114		//sprzedaz wewnatrzunijna
#define FWS		116		//Faktura wewnetrzna sprzedaz
#define WKS		118		//Faktura korygujca wewntrzna (sprzeday)
#define WDK		120		//Wewntrzwsplnotowa dostawa towaru korekta
#define FVT		124		//Faktura VAT mara	(inaczej: turystyczna)
#define FTK		125		//Faktura VAT mara (inaczej: turystyczna) korekta
#define REX		126		//Rachunek eksportowy
#define RXK		127		//Rachunek eksportowy korekta
//...
#ifdef HM
///////////////////////////////////////////////////////////////////////////
// dokumenty zakupu
#define FVZ      68      // faktura VAT zakupu
#define FKZ      69      // faktura korygujaca VAT zakupu
#define RUZ      70      // rachunek uproszczony zakupu
#define RKZ      71      // rachunek korygujacy VAT zakupu
#define DIM      72      // dokument importowy
#define DKM      73      // dokument importowy korekta
#define FZZ		110		//Faktura zaliczkowa zakupu
#define KZZ		111		//Kontrakt zaliczkowy zakupu
#define ZKZ		113		//Faktura korygujaca zaliczkowa zakupu
#define FWZ		117		//Faktura wewnetrzna zakupu
#define WNT		115		 // zakup wewnatrzunijny
#define WKZ		119		//Faktura korygujca wewntrzna (zakupu)
#define WNK		121		//Wewntrzwsplnotowe nabycie towaru korekta
//...
#endif

#ifdef HMHL
#define FVR      99      // fakura VAT RR
#define FKR      100     // faktura korygujca VAT RR
#endif

#define UPDATE_ROZLICZ_HANDL 0
// 1 - aktualizacja rozliczen handlowych dla wszystkich dokumentow zakupu koerkt badz korygowanych
// 0 - aktualizacja rozliczen handlowych dla wybranych przez diagnopstyke dokumentow zakupu koerkt badz korygowanych

#define VAT_NP 255
string sRaportDescription
int Sub CzyDokVAT(int iTyp)
	Select Case iTyp
		Case FVS, FKS, RUS, RKS, FVW, FKW, FVM, FKM, FZS, KZS, ZKS, FWS, WKS, FVT, FTK, PAR, PRK
			CzyDokVAT = 1
#ifdef HM
		Case FVZ, FKZ, RUZ, RKZ, DIM, DKM, FZZ, KZZ, ZKZ, WNT, FWZ, WNK, WKZ
			CzyDokVAT = 1
#endif
		Case Else
			CzyDokVAT = 0
	EndSelect
EndSub

int Sub CzyFaktWew(int iTyp)
	Select Case iTyp
		Case FWS, WKS
			CzyFaktWew = 1
#ifdef HM
		Case FWZ, WKZ
			CzyFaktWew = 1
#endif
		Case Else
			CzyFaktWew = 0
	EndSelect
EndSub

int Sub CzyNumerNP(int stvat, int sTyp)
	if CzyDokVAT(sTyp) && stvat==VAT_NP then
		CzyNumerNP = 1
	else
		CzyNumerNP = 0
	endif
EndSub

#include "Diagnostyka - funkcje"
UsunRekord_0("DP")

sDialogTitle += "pozycji dokumentw handlowych"

StageAddDesc("Raport porwnuje sum wartoci NETTO oraz VAT z pozycji dokumentw z")
StageAddDesc("wartociami zapisanymi w dokumentach oraz porwnuje zawartoci baz DP")
StageAddDesc("oraz IDP.")
StageAddStage("Sprawdzenie integralnoci bazy DP oraz IDP")
StageAddStage("Sprawdzenie poprawnoci pozycji")
StageAddStage("Porwnanie sumy pozycji z dokumentem")
StageAddStage("Sprawdzenie dugich nazw")
ChooseStages(400)

BaseDK dk
BaseAll nt
BaseAll nt2
BaseAll dp
BaseAll dp2
BaseAll xt
BaseTW tw
BaseZZ zz
#ifdef HMHL
BaseMZ mz
#endif
BaseAll bp
long idp
int byly, err2
int typ, bKorekta, TypPozComm, lpTypPozComm, iCzyAktualiz
int nStVat3 = -1

MapValue mvKomplet
mvKomplet.Type(long)
string strKomplet

float vat,netto,vatdk,nettodk,fKurs
long id, curr_lp,idrenum,last_dok, lSuper, idBazow,curr_lp_NP
string sRej, sTmp

#include "Diagnostyka pozycji handlowych - include"


// **********************



OpenBaseB(dp,"DP")
OpenBaseB(dp2,"DP")
OpenBaseB(nt,"NT")
OpenBaseB(nt2,"NT")
OpenBaseB(xt,"XT")
OpenBaseB(bp,"BP")
dk.Open()

#ifdef HMHL
mz.Open()


int Sub UstawWszytskie(long idBazow, int WI)
//WI == 1 poprawiamy wartosc
//WI == 0 poprawiamy ilosc
//WI == 2 poprawiamy obydwa
	
	float vat,netto
	int err, err2

	BaseAll mdp
	BaseMZ mmz
	BaseAll mdp2

	OpenBaseB(mdp,"DP")
	if mmz.Open() then error "Bd otwierania bazy MZ"
	OpenBaseB(mdp2,"DP")

	err = mdp.GetRecById(idBazow)
	
	while !err
		netto = vat = 0
		mmz.SetKey("idhandl")
		mmz.SetKeySeg("idhandl",mdp.GetField("id"))
		mmz.SetKeySeg("data","")
		err=mmz.GetRec(GE)
		while !err && mmz.GetField("idhandl")==mdp.GetField("id")
			netto += mmz.GetField("wartNetto") + mmz.GetField("wartk")
			vat += mmz.GetField("ilosc")
			err=mmz.GetRec(NX)
		wend
		if mdp.GetField("idpozkoryg") then
			mdp2.SetKey("super")
			mdp2.SetKeySeg("super",mdp.GetField("super"))
			mdp2.SetKeySeg("lp",mdp.GetField("lp"))
			err2 = mdp2.GetRec(EQ)
			while !err2 && mdp2.GetField("super")==mdp.GetField("super") && mdp2.GetField("lp")==mdp.GetField("lp") && mdp2.GetField("id")==mdp.GetField("id")
				err2 = mdp2.GetRec(NX)
			wend
			if mdp2.GetField("super")==mdp.GetField("super") && mdp2.GetField("lp")==mdp.GetField("lp") && mdp2.GetField("id")!=mdp.GetField("id") then
				vat = ((-1)*mdp2.GetField("ilosc"))+vat
				netto = ((-1)*mdp2.GetField("wartTowaru"))+netto
			endif
		endif

		if WI==1 || WI == 2 then
			mdp.SetField("wartTowaru",netto)
			mdp.SetField("cenaBaza",0)
//			mdp.SetField("cenabaztow",mdp.GetField("wartNetto"))
		endif
		if WI==0 || WI == 2 then
			mdp.SetField("iloscDoRozl",mdp.GetField("ilosc")-vat)
			mdp.SetField("rozlhandl",0)
		endif
		UpdateRecB(mdp)
		
		mdp.SetKey("idpozkoryg")
		mdp.SetKeySeg("idpozkoryg",mdp.GetField("id"))
		err=mdp.GetRec(EQ)
	wend
	
	mdp.Close()
	mmz.Close()
	
EndSub
#endif

int Sub CzyWartOK(long idBazow)
	
	int err
	float wart = 0
	
	BaseAll mdp
	OpenBaseB(mdp,"DP")
	err = mdp.GetRecById(idBazow)
		
	while !err
		wart += mdp.GetField("cenaBaza")
		mdp.SetKey("idpozkoryg")
		mdp.SetKeySeg("idpozkoryg",mdp.GetField("id"))
		err=mdp.GetRec(EQ)
	wend
	
	mdp.Close()

	CzyWartOK = Sign(wart)
EndSub

TextOut("Podsumowanie sprawdzania poprawnoci bazy pozycji dokumentw handlowych\n\n")


if StageT(1) then SprawdzIDP()
StageSummary(1)


PopUp(1,"Sprawdzanie dowiza pozycji do dokumentw")

nt.SetKey("super")
nt2.SetKey("id")
dk.SetKey("id")
dp.SetKey("super")
dp.SetKeySeg("super",0)
dp.SetKeySeg("lp",0)

#ifdef HMHL
dp2.SetKey("idpozkoryg")
mz.SetKey("idhandl")
#endif

last_dok=0
err=dp.GetRec(GE)
progress.Reset(dp.GetRecordCount())

if !StageT(2) then err=1

if xt.GetRecById(10005) then error "Brak rekordu 'Bazy'"
if (xt.GetField("wartosc") == 0.03) then
	nStVat3 = xt.GetField("long")
else
	if xt.GetRecById(10006) then error "Brak rekordu 'Bazy'"
	if (xt.GetField("wartosc") == 0.03) then
		nStVat3 = xt.GetField("long")
	endif
endif

while !err
	progress.NextOne()
	dk.SetKeySeg("id",dp.GetField("super"))

#ifdef HMHL
	if (!dk.GetRec(EQ) && !(dk.GetField("exp_fki") & 0x20)) && !(dp.GetField("typi") & 0x10) && dp.GetField("flag")&0x0200 && !(dp.GetField("flag")&0x2000) && !(dp.GetField("typi") & 0x01)  then
		// sprawdzenie wartoci iloscdorozl i wartTowaru
		if (dp.GetField("flag") & 0x0100) != (dk.GetField("flag") & 0x0100) then 
			if (dk.GetField("flag") & 0x0100) then
				dp.SetField("flag",dp.GetField("flag")|0x0100)
			else
				dp.SetField("flag",dp.GetField("flag")^0x0100)
			endif
			UpdateRecB(dp)
		endif


		dp2.SetKey("idpozkoryg")
		dp2.SetKeySeg("idpozkoryg",dp.GetField("id"))
		if !dp2.GetRec(EQ) then
			iCzyAktualiz = 1
			if !dp.GetField("idpozkoryg") then
				idBazow = dp.GetField("id")
			else
				idBazow = dp.GetField("idpozkoryg")
					
				while !dp2.GetRecById(idBazow) && dp2.GetField("idpozkoryg")
					idBazow = dp2.GetField("idpozkoryg")
				wend
			endif
		else		
			if dp.GetField("idpozkoryg") then
				iCzyAktualiz = 1
				idBazow = dp.GetField("idpozkoryg")

				while !dp2.GetRecById(idBazow) && dp2.GetField("idpozkoryg")
					idBazow = dp2.GetField("idpozkoryg")
				wend
			else
				iCzyAktualiz = 0
				idBazow = dp.GetField("id")
			endif
		endif

		netto = vat = 0
		mz.SetKeySeg("idhandl",dp.GetField("id"))
		mz.SetKeySeg("data","")
		err=mz.GetRec(GE)
		while !err && mz.GetField("idhandl")==dp.GetField("id")
			netto += mz.GetField("wartNetto") + mz.GetField("wartk")
			vat += mz.GetField("ilosc")
			err=mz.GetRec(NX)
		wend

		if dp.GetField("idpozkoryg") then
			dp2.SetKey("super")
			dp2.SetKeySeg("super",dp.GetField("super"))
			dp2.SetKeySeg("lp",dp.GetField("lp"))
			err2 = dp2.GetRec(EQ)
			while !err2 && dp2.GetField("super")==dp.GetField("super") && dp2.GetField("lp")==dp.GetField("lp") && dp2.GetField("id")==dp.GetField("id")
				err2 = dp2.GetRec(NX)
			wend
			if dp2.GetField("super")==dp.GetField("super") && dp2.GetField("lp")==dp.GetField("lp") && dp2.GetField("id")!=dp.GetField("id") then
				vat = ((-1)*dp2.GetField("ilosc"))+vat
				netto = ((-1)*dp2.GetField("wartTowaru"))+netto
				if dp2.GetField("iloscDoRozl") then
					TextOut(using "Pozycja wyrwnujca '%s' id=%l posiada ilo do rozliczenia",dp2.GetField("kod"),dp2.GetField("id"))
					dp2.SetField("iloscDoRozl",0)
					UpdateRecB(dp2)
				endif
			endif
		endif

		if last_dok!=dp.GetField("super") && (((dp.GetField("flag") & 0x0100) && iCzyAktualiz && UPDATE_ROZLICZ_HANDL) || ((dp.GetField("flag") & 0x0100) && iCzyAktualiz && CzyWartOK(idBazow))) then
			if TextOutAndAsk3(13,(using "Nie zgadza si warto towaru rozliczonego magazynowo w pozycji '%s' id=%l",dp.GetField("kod"),dp.GetField("id"))) then
				UstawWszytskie(idBazow,2)
				UpdateRozliczHandl(dp.GetField("id"),(idBazow == dp.GetField("id")))
			else
				TextOut(sNoRepair)
			endif
		endif
		if (Sign(dp.GetField("wartTowaru")-(iif(dp.GetField("flag") & 0x0100,dp.GetField("cenaBaza"),0))-netto)) then
			if TextOutAndAsk(13,(using "Nie zgadza si warto towaru rozliczonego magazynowo w pozycji '%s' id=%l",dp.GetField("kod"),dp.GetField("id")),(using "\njest:%.2f  powinno by:%.2f\nCzy naprawi?",(dp.GetField("wartTowaru")-(iif(dp.GetField("flag")&0x0100,dp.GetField("cenaBaza"),0))),netto)) then
				if (dp.GetField("flag") & 0x0100) && iCzyAktualiz then
					UstawWszytskie(idBazow,1)
					UpdateRozliczHandl(dp.GetField("id"),(idBazow == dp.GetField("id")))
				else							
					dp.SetField("wartTowaru",netto)
					UpdateRecB(dp)					
				endif
			else
				TextOut(sNoRepair)
			endif
		endif
		if Sign(dp.GetField("ilosc")-dp.GetField("iloscDoRozl")-dp.GetField("rozlhandl")-vat,4) then
			if TextOutAndAsk(14,(using "Nie zgadza si ilo towaru rozliczonego magazynowo w pozycji '%s' id=%l",dp.GetField("kod"),dp.GetField("id")),(using "\njest:%.2f  powinno by:%.2f\nCzy naprawi?",dp.GetField("iloscDoRozl"),dp.GetField("ilosc")-dp.GetField("rozlhandl")-vat)) then
				if iCzyAktualiz then
					UstawWszytskie(idBazow,0)
					UpdateRozliczHandl(dp.GetField("id"),(idBazow == dp.GetField("id")))
				else
					dp.SetField("iloscDoRozl",dp.GetField("ilosc")-vat)
					UpdateRecB(dp)				
				endif	
			else
				TextOut(sNoRepair)
			endif
		endif
		if (dp.GetField("flag") & 0x0100) then //dla zakupu sprawdzamy czy koszt w pozycji nie jest mniejszy od wartoci pz-tw
			if (idBazow==dp.GetField("id") && Sign(dp.GetField("cenabaztow")-dp.GetField("cenaBaza")-netto ) > 0) || (idBazow!=dp.GetField("id") && Sign(iif(Sign(dp.GetField("cenabaztow"))>0,-1,1)*(dp.GetField("cenabaztow")-dp.GetField("cenaBaza")-netto )) > 0) then
				if TextOutAndAsk(15,(using "Koszt zakupu jest mniejszy od faktycznej wartoci towaru w pozycji '%s' id=%l",dp.GetField("kod"),dp.GetField("id")),(using "\njest:%.2f  powinno by:%.2f\nCzy naprawi?",dp.GetField("cenabaztow")-(iif(dp.GetField("flag") & 0x0100,dp.GetField("cenaBaza"),0)),netto)) then
					dp.SetField("cenabaztow",netto)
					UpdateRecB(dp)
					if iCzyAktualiz then
						UpdateRozliczHandl(dp.GetField("id"),(idBazow == dp.GetField("id")))
					endif	
				else
					TextOut(sNoRepair)
				endif
			endif
		endif
	endif		
#endif

	// sprawdzenie stawki vat
#ifdef HMHL
	if ((dk.GetField("subtypi") == FVR || dk.GetField("subtypi") == FKR)) then
		if (dk.GetField("datasp")>="2004-05-01") then
			if (dp.GetField("stvati")!=6) then
				TextOut(using "Pozycja '%s' id=%l na niewaciwie okrelon stawk VAT",dp.GetField("kod"),dp.GetField("id"))
				dp.SetField("stvati", 6) //5% Stawka dla faktur VAT RR
				if dp.Update() then
					TextOut(" - NIE NAPRAWIONO: Bd zapisu do bazy DP\n")
				else
					TextOut(sRepaired)
				endif
			endif
		else
			if (nStVat3!=-1 && dp.GetField("stvati")!=nStVat3) then
				TextOut(using "Pozycja '%s' id=%l na niewaciwie okrelon stawk VAT",dp.GetField("kod"),dp.GetField("id"))
				dp.SetField("stvati", nStVat3) //3% Stawka dla faktur VAT RR
				if dp.Update() then
					TextOut(" - NIE NAPRAWIONO: Bd zapisu do bazy DP\n")
				else
					TextOut(sRepaired)
				endif
			endif
		endif
	else
#endif
		if (dp.GetField("stvati")>6 || dp.GetField("stvati")<0) && dp.GetField("stvati")!=255 then
			TextOut(using "Pozycja '%s' id=%l na niewaciwie okrelon stawk VAT",dp.GetField("kod"),dp.GetField("id"))
			if tw.GetRecById(dp.GetField("idtw")) then
				dp.SetField("stvati",0)
			else
				dp.SetField("stvati",tw.GetField("vatspi"))
			endif
			if dp.Update() then
				TextOut(" - NIE NAPRAWIONO: Bd zapisu do bazy DP\n")
			else
				TextOut(sRepaired)
			endif
		endif
#ifdef HMHL
	endif
#endif

	// sprawdzanie poprawnoci rezerwacji
	if ((firma.code == "HM") || (firma.code == "HL")) && dp.GetField("rezerwacja") then
		if zz.GetRecById(dp.GetField("rezerwacja")) || zz.GetField("typi")!=96 || zz.GetField("baza3")!=16 || zz.GetField("id3pos")!=dp.GetField("id") then
			if TextOutAndAsk3(7,using "Pozycja '%s' id=%l wskazuje na nieprawidow rezerwacje",dp.GetField("kod"),dp.GetField("id")) then
				dp.SetField("rezerwacja",0)
				UpdateRecB(dp)
			else
				TextOut(sNoRepair)
			endif
		endif
	endif

	// czy istnieje dokument
	if !dp.GetField("super") then
		TextOut(using "Pozycja '%s' id=%l jest dowizana do dokumentu id=0",dp.GetField("kod"),dp.GetField("id"))
		Usun_notatke(dp.GetField("id"))
		DeleteRecB(dp)
	else
		if dp.GetField("super")!=last_dok then last_dok=0
		if !last_dok then
			dk.SetKeySeg("id",dp.GetField("super"))
			if dk.GetKey(EQ) then
				if TextOutAndAsk2(3,(using "Pozycja '%s' id=%l jest dowizana do dokumentu, ktry nie istnieje (id=%l)",dp.GetField("kod"),dp.GetField("id"),dp.GetField("super")),". Zalecane jest uruchomienie raportu diagnostycznego bazy dokumentw.","[&Nie usuwaj pozycji:p](&Usu pozycje:o)(&Przerwij:a)") then
					Usun_notatke(dp.GetField("id"))
					DeleteRecB(dp)
				else
					TextOut(" - NIE USUNITO - uruchom raport diagnostyczny bazy dokumentw\n")
				endif
			else
				last_dok=dp.GetField("super")
			endif			
		endif
	endif
	err=dp.GetRec(NX)
wend

StageSummary(2)



WriteStatusBar("Sprawdzanie pozycji dokumentw")
PopUp(1,"Sprawdzanie pozycji dokumentu:")
PopUp(2,"")

dk.SetKey("id")
dp.SetKey("super")
err=dk.GetRec(FS)

progress.Reset(dk.GetRecordCount())

if !StageT(3) then err=1

while !err
	progress.NextOne()
	typ=dk.GetField("typi")
	if (!typ || typ==201 || typ==202 || typ==100 || typ==111 || typ==112) && dk.GetField("subtypi")!=0 && dk.GetField("subtypi")!=1 && dk.GetField("subtypi")!=2 && dk.GetField("subtypi")!=3 then

		// naliczenie netto i vat

		PopUp(2,dk.GetField("kod"))
		id=dk.GetKeySeg("id")
		dp.SetKey("super")
		dp.SetKeySeg("super",id)
		dp.SetKeySeg("lp",-32768)
		netto=vat=0
		err=dp.GetRec(GE)
		bKorekta = !!dk.GetField("iddokkoryg")
		curr_lp = 0
		curr_lp_NP = 10000
		idrenum=0
		lpTypPozComm = 0
		TypPozComm = -1
		mvKomplet.Clear()
		while !err && dp.GetKeySeg("super")==id
			if !bKorekta then
				if (dp.GetField("lp")<=0) || (!(dp.GetField("flag")&0x4000) && dp.GetField("lp")-iif(CzyNumerNP(dp.GetField("stvati"), dk.GetField("subtypi")),curr_lp_NP,curr_lp)!=1) then idrenum=id
				if ( dp.GetField("flag")&0x4000 && (dp.GetField("lp")-iif(CzyNumerNP(dp.GetField("stvati"), dk.GetField("subtypi")),curr_lp_NP,curr_lp))) then
					dp2.SetKey("super")
					dp2.SetKeySeg("super",dp.GetField("super"))
					dp2.SetKeySeg("lp",dp.GetField("lp"))
					err2 = dp2.GetRec(EQ)
					while !err2 && dp2.GetField("super")==dp.GetField("super") && dp2.GetField("lp")==dp.GetField("lp") && !(dp2.GetField("flag")&0x1000)
						err2 = dp2.GetRec(NX)
					wend
					if dp2.GetField("super")!=dp.GetField("super") || dp2.GetField("lp")!=dp.GetField("lp") || !(dp2.GetField("flag")&0x1000) then
						idrenum=id
					endif
				endif
			endif

			if !(dp.GetField("flag")&0x4000) then
				if CzyNumerNP(dp.GetField("stvati"), dk.GetField("subtypi")) then
					curr_lp_NP=dp.GetField("lp")
				else
					curr_lp=dp.GetField("lp")
				endif
			endif

			if !CzyFaktWew(dk.GetField("subtypi")) && !(dp.GetField("flag")&0x2000) then
				if (dp.GetField("flag")&0x1000) || (dp.GetField("flag")&0x4000) then
					if !dp.GetField("idpozkoryg") then
						if dp.GetField("lp") != lpTypPozComm then
							lpTypPozComm = dp.GetField("lp")
							if (dp.GetField("flag")&0x1000) then
								TypPozComm =  dp.GetField("typi")&0x01
								if TypPozComm then
									strKomplet = using "%d",lpTypPozComm
									mvKomplet.Set(strKomplet,dp.GetField("id"))
								endif
							else
								dp2.SetKey("super")
								dp2.SetKeySeg("super",dp.GetField("super"))
								dp2.SetKeySeg("lp",dp.GetField("lp"))
								err2 = dp2.GetRec(EQ)
								while !err2 && dp2.GetField("super")==dp.GetField("super") && dp2.GetField("lp")==dp.GetField("lp") && !(dp2.GetField("flag")&0x1000)
									err2 = dp2.GetRec(NX)
								wend
								if dp2.GetField("super")==dp.GetField("super") && dp2.GetField("lp")==dp.GetField("lp") && (dp2.GetField("flag")&0x1000) then
									TypPozComm =  dp2.GetField("typi")&0x01
								else
									TypPozComm = 1
								endif
							endif
						endif
						if (dp.GetField("flag")&0x4000) then
							strKomplet = using "%d",lpTypPozComm
							if mvKomplet.Index(strKomplet) then
								mvKomplet.Del(strKomplet)
							endif							
						endif
						if (dp.GetField("flag")&0x4000) && (!(dp.GetField("typi")&0x01) != TypPozComm) then
							if dp.GetField("typi")&0x01 then
								dp.SetField("typi",dp.GetField("typi")^0x01)
							else
								dp.SetField("typi",dp.GetField("typi")|0x01)
							endif
							UpdateRecB(dp)
						endif
					else
						//tak jak bazowy
						idp = dp.GetField("idpozkoryg")
						do
							dp2.SetKey("id")
							dp2.SetKeySeg("id",idp)
							err2 = dp2.GetRec(EQ)
							if !err2 && dp2.GetField("idpozkoryg") then
								idp = dp2.GetField("idpozkoryg")
							else
								idp = dp2.GetField("typi")&0x01
							endif
						loop while !err2 && dp2.GetField("idpozkoryg")
						if !err2 && (dp.GetField("typi")&0x01) != idp then
							if dp.GetField("typi")&0x01 then
								dp.SetField("typi",dp.GetField("typi")^0x01)
							else
								dp.SetField("typi",dp.GetField("typi")|0x01)
							endif
							UpdateRecB(dp)
						endif						
					endif
				else
					if dp.GetField("typi")&0x01 then
						dp.SetField("typi",dp.GetField("typi")^0x01)
						UpdateRecB(dp)
					endif
				endif
			else
				if !(dp.GetField("typi")&0x01) then
					dp.SetField("typi",dp.GetField("typi")|0x01)
					UpdateRecB(dp)
				endif
			endif

			if !(dp.GetField("typi") & 1) || CzyFaktWew(dk.GetField("subtypi")) then				// 1=komplet lub anulowana
				netto+=dp.GetField("wartNetto")
				vat+=dp.GetField("wartVat")
			endif

#ifdef HMHL
			if (!CzyFaktWew(dk.GetField("subtypi")) && (dp.GetField("magazyn")!=dk.GetField("magazyn"))) then
				if TextOutAndAsk3(12,(using "Nie zgadza si magazyn pozycji '%s' dokumentu '%s'",dp.GetField("kod"),dk.GetField("kod"))) then
					dp.SetField("magazyn",dk.GetField("magazyn"))
					UpdateRecB(dp)
				else
					TextOut(sNoRepair)
				endif
			endif
#endif

			sRej = (using "%d",dp.GetField("rejestrVati"))
			lSuper = iif(dp.GetField("flag")&0x0100,10700,10500)  // 10700 dla zakupu 10500 dla sprzedazy
			xt.SetKey("super")
			xt.SetKeySeg("super", lSuper)
			xt.SetKeySeg("kod", "")
			err = xt.GetRec(GE)
			while !err && xt.GetKeySeg("super") == lSuper					
				sTmp = Using "%l", xt.GetField("long")							
				if sRej == sTmp then
					exit // OK wyjcie z ptli
				endif
				err = xt.GetRec(NX)
			wend

			if !(dp.GetField("typi")&0x10) then
				if ((dp.GetField("rejestrVati")!= dk.GetField("rejestrVati")) && (sRej != sTmp)) || dp.GetField("data")!= dk.GetField("data") || dp.GetField("datarej")!= dk.GetField("datarej")then 
					dp.SetField("data",dk.GetField("data"))
					if ((dp.GetField("rejestrVati")!= dk.GetField("rejestrVati")) && (sRej != sTmp))  then dp.SetField("rejestrVati",dk.GetField("rejestrVati"))
					dp.SetField("datarej",dk.GetField("datarej"))

					if dp.Update() then
						TextOut(using "Nie zgadza si rejestr VAT oraz data na pozycji '%s' dokumentu '%s' - NIE NAPRAWIONO - bd zapisu do bazy DP\n",dp.GetField("kod"),dk.GetField("kod"))
					else
						TextOut(using "Nie zgadza si rejestr VAT oraz data na pozycji '%s' dokumentu '%s' - NAPRAWIONO\n",dp.GetField("kod"),dk.GetField("kod"))
					endif
				endif
			else
				if (dp.GetField("rejestrVati")!= dk.GetField("rejestrVati"))  || dp.GetField("data")!= dk.GetField("data") || dp.GetField("datarej")!= dk.GetField("datarej") then
					dp.SetField("rejestrVati",dk.GetField("rejestrVati"))
					if dp.Update() then
						TextOut(using "Nie zgadza si rejestr VAT na pozycji ukrytej id = '%d' dokumentu '%s' - NIE NAPRAWIONO - bd zapisu do bazy DP\n",dp.GetField("id"),dk.GetField("kod"))
					else
						TextOut(using "Nie zgadza si rejestr VAT na pozycji ukrytej id = '%d' dokumentu '%s' - NAPRAWIONO\n",dp.GetField("id"),dk.GetField("kod"))
					endif
				endif
			endif
			if dp.GetField("subtypi")!=dk.GetField("typi") then
				if TextOutAndAsk3(8,using "Pozycja '%s' id=%l dokumentu '%s' ma subtyp niezgodny z typem dokumentu",dp.GetField("kod"),dp.GetField("id"),dk.GetField("kod")) then
					dp.SetField("subtypi",dk.GetField("typi"))
					UpdateRecB(dp)
				else
					TextOut(sNoRepair)
				endif
			endif
			// czy istnieje dokument zamwienia
			if dp.GetField("idhandl") then
				if bp.GetRecById(dp.GetField("idhandl")) then
					if TextOutAndAsk3(16,using "Pozycja '%s' id=%l wskazuje na nieistniejc pozycj dokumentu zamwienia",dp.GetField("kod"),dp.GetField("id")) then
						dp.SetField("idhandl",0)
						UpdateRecB(dp)
					else
						TextOut(sNoRepair)
					endif
				endif
			endif

			err=dp.GetRec(NX)
		wend
		if idrenum then
			if TextOutAndAsk(1,(using "Pozycje dokumentu '%s' maj nieuporzdkowane numery",dk.GetField("kod")),". Czy uporzdkowa numery pozycji dokumentu") then
				Przenumeruj(idrenum,(using "%d",dk.GetField("subtypi")))
			else
				TextOut(sNoRepair)
			endif
		else
			while mvKomplet.Size()
				dp.GetRecById(mvKomplet.Get(mvKomplet.Size()))
				dp.SetField("typi",dp.GetField("typi")^0x01)
				UpdateRecB(dp)
				netto+=dp.GetField("wartNetto")
				vat+=dp.GetField("wartVat")
				mvKomplet.Del(mvKomplet.GetKey(mvKomplet.Size()))
			wend
		endif
		fKurs=dk.GetField("kurs")
		if !sign(fKurs,4) then fKurs=1
		nettodk=dk.GetField("netto")/fKurs
		vatdk=dk.GetField("vat")/fKurs
		netto/=fKurs
		vat/=fKurs
		if Sign(nettodk-netto,2) || Sign(vatdk-vat,2) then
			byly=1
			TextOut("Nie zgadza si warto ")
			if Sign(nettodk-netto,2) && Sign(vatdk-vat,2) then
				TextOut("NETTO oraz VAT")
			else
				if Sign(nettodk-netto,2) then TextOut("NETTO")
				if Sign(vatdk-vat,2) then TextOut("VAT")
			endif
			TextOut(using " w dokumencie '%s'\n",dk.GetField("kod"))
		endif
	endif

	err=dk.GetRec(NX)
wend

StageSummary(3)

PopUp(1,"Sprawdzanie notatek do pozycji")
PopUp(2,"")
WriteStatusBar("Sprawdzanie notatek do pozycji")


if StageT(4) then

dp.SetKey("id")
nt.SetKey("id")
nt2.SetKey("super")
nt2.SetKeySeg("typi",16)
nt2.SetKeySeg("baza",18)
err=dp.GetRec(FS)
progress.Reset(dp.GetRecordCount())
while !err
	progress.NextOne()
  if dp.GetField("idlongname") then
		nt.SetKeySeg("id",dp.GetField("idlongname"))
    if nt.GetRec(EQ) || nt.GetField("typi")!=16 || nt.GetField("baza")!= 18 || nt.GetFIeld("super")!=dp.GetField("id") then
			nt2.SetKeySeg("super",dp.GetField("id"))
			id = 0
			if !nt2.GetRec(EQ) then id=nt2.GetField("id")
      if TextOutAndAsk3(9,(using "Pozycja '%s' id=%l ma niewaciwie powizan dug nazw",dp.GetField("kod"),dp.GetField("id"))) then
	 	    dp.SetField("idlongname",id)
  	 	  UpdateRecB(dp)
			else
				TextOut(sNoRepair)
			endif
		endif
  endif
	
	err=dp.GetRec(NX)
wend

nt.SetKey("super")
nt.SetKeySeg("typi",16)
nt.SetKeySeg("baza",18)
dp.SetKey("id")
err=nt.GetRec(GE)
while !err && nt.GetField("typi")==16 && nt.GetField("baza")==18
	dp.SetKeySeg("id",nt.GetField("super"))
	if dp.GetRec(EQ) then
		if TextOutAndAsk3(10,(using "W bazie notatek znajduje si rekord o numerze %d odwoujcy si do nieistniejcej pozycji",nt.GetField("id"))) then
			DeleteRecB(nt)
		else
			TextOut(sNoRepair)
		endif
	else
		if dp.GetField("idlongname")!=nt.GetField("id") then
      if TextOutAndAsk3(11,(using "Pozycja '%s' id=%l ma niewaciwie powizan dug nazw",dp.GetField("kod"),dp.GetField("id"))) then
	 	    dp.SetField("idlongname",nt.GetField("id"))
  	 	  UpdateRecB(dp)
			else
				TextOut(sNoRepair)
			endif
		endif
	endif
	err=nt.GetRec(NX)
wend

StageSummary(4)

endif		// stage

TextOut("\nZakoczono.")

print using "\n\nPowysze podsumowanie zostao zapisane w katalogu %s do pliku %s\n",KatalogFirmy(),NAZWA_PLIKU
if byly then
	TextOut("\nUWAGA!!! W wymienionych wyej dokumentach nie zgadza si suma wartoci NETTO lub VAT z pozycji dokumentw z wartoci zapisan w dokumencie.\n")
	TextOut("Prosz odszuka wymienione dokumenty w programie i porwna ich zawarto z wczeniejszymi wydrukami tych dokumentw.\nPo stwierdzeniu niezgodnoci z orginaem naley przej do edycji i poprawi wszystkie zauwaone bdy.")
endif


close
